/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * http://aipostyle.com/
 * 
 * Copyright(C) 2010 avanza Co.,Ltd. All rights reserved.
 * http://www.avnz.co.jp/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.modules.parameters;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.jetspeed.modules.parameters.ListBox;
import org.apache.turbine.util.RunData;

import com.aimluck.eip.extcabinet.ExtFolderInfo;
import com.aimluck.eip.extcabinet.util.ExtCabinetUtils;

/**
 */
public class ExtCabinetFolderListBox extends ListBox {

  public static final String INITIAL_VALUE = "initialvalue";

  /**
   * 文書管理の設定値を処理するクラスです。 <br />
   * 
   * @param data
   */
  protected void init(RunData data) {
    // カテゴリ一覧を取得
  	List<ExtFolderInfo> folder_hierarchy_list = 
  		ExtCabinetUtils.getFolderList(ExtCabinetUtils.ROOT_PARENT_FODLER_ID);
    
    //権限的に参照可能なフォルダーのみに絞る
    ExtCabinetUtils.setFolderAuthorizedVisible(folder_hierarchy_list, data);
    Iterator<ExtFolderInfo> it = folder_hierarchy_list.iterator();
    List<ExtFolderInfo> tmpList = new ArrayList<ExtFolderInfo>();
    while (it.hasNext()) {
      ExtFolderInfo folderinfo = (ExtFolderInfo) it.next();
      if( !folderinfo.isAuthorizedVisible() ) {
        continue;
      }
      tmpList.add(folderinfo);
    }
    folder_hierarchy_list = tmpList;

    int length = folder_hierarchy_list.size();
    String[] folderKeys = new String[length];
    String[] folderValues = new String[length];

    int count = 0;

    // カテゴリの登録
    ExtFolderInfo folderinfo = null;
    Iterator<ExtFolderInfo> iter = folder_hierarchy_list.iterator();
    while (iter.hasNext()) {
      folderinfo = (ExtFolderInfo) iter.next();
      
      StringBuffer nbsps = new StringBuffer();
      int len = folderinfo.getHierarchyIndex();
      for (int i = 0; i < len; i++) {
        nbsps.append("&nbsp;&nbsp;&nbsp;");
      }

      folderKeys[count] = "" + folderinfo.getFolderId();
      folderValues[count] = nbsps.toString() + folderinfo.getFolderName();
      count++;
    }

    this.layout = (String) this.getParm(LAYOUT, LAYOUT_COMBO);
    this.items = folderKeys;
    this.values = folderValues;
    this.size = Integer.toString(length);
    this.multiple = Boolean.valueOf(
        (String) this.getParm(MULTIPLE_CHOICE, "false")).booleanValue();

  }
}
